#pragma once

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace MorphTest {

	/// <summary>
	/// ProgressForm ̊Tv
	///
	/// x: ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public ref class ProgressForm : public System::Windows::Forms::Form
	{
	public:
		ProgressForm(void)
		{
			InitializeComponent();
		}

	protected:
		/// <summary>
		/// gp̃\[XׂăN[Abv܂B
		/// </summary>
		~ProgressForm()
		{
			if (components)
			{
				delete components;
			}
		}
	public: System::Windows::Forms::ProgressBar^  progressBar;
	public: System::Windows::Forms::Button^  buttonCancel;
	public: System::Windows::Forms::Label^  label;
	private: 
	protected: 

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			this->progressBar = (gcnew System::Windows::Forms::ProgressBar());
			this->buttonCancel = (gcnew System::Windows::Forms::Button());
			this->label = (gcnew System::Windows::Forms::Label());
			this->SuspendLayout();
			// 
			// progressBar
			// 
			this->progressBar->Location = System::Drawing::Point(13, 13);
			this->progressBar->Name = L"progressBar";
			this->progressBar->Size = System::Drawing::Size(267, 23);
			this->progressBar->TabIndex = 0;
			// 
			// buttonCancel
			// 
			this->buttonCancel->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->buttonCancel->Location = System::Drawing::Point(103, 58);
			this->buttonCancel->Name = L"buttonCancel";
			this->buttonCancel->Size = System::Drawing::Size(75, 23);
			this->buttonCancel->TabIndex = 1;
			this->buttonCancel->Text = L"Cancel";
			this->buttonCancel->UseVisualStyleBackColor = true;
			// 
			// label
			// 
			this->label->AutoSize = true;
			this->label->Location = System::Drawing::Point(12, 39);
			this->label->Name = L"label";
			this->label->Size = System::Drawing::Size(0, 12);
			this->label->TabIndex = 2;
			// 
			// ProgressForm
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 12);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->CancelButton = this->buttonCancel;
			this->ClientSize = System::Drawing::Size(292, 89);
			this->ControlBox = false;
			this->Controls->Add(this->label);
			this->Controls->Add(this->buttonCancel);
			this->Controls->Add(this->progressBar);
			this->FormBorderStyle = System::Windows::Forms::FormBorderStyle::FixedDialog;
			this->MaximizeBox = false;
			this->MinimizeBox = false;
			this->Name = L"ProgressForm";
			this->Text = L"͒";
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	};

	ref class ProgressDialog
	{
	private:
		bool canceled;
		ProgressForm^ form;
		System::Threading::ManualResetEvent^ startEvent;
		bool showed;
		bool closing;
		System::Windows::Forms::Form^ ownerForm;
		System::Threading::Thread^ thread;

		System::String^ title;
		int minimum;
		int maximum;
		int value;
		System::String^ message;

		
		void SetProgressValue()
		{
			if (form != nullptr && !form->IsDisposed)
				form->progressBar->Value = value;
		}

		void SetMessage()
		{
			if (form != nullptr && !form->IsDisposed)
				form->label->Text = message;
		}

		void SetTitle()
		{
			if (form != nullptr && !form->IsDisposed)
				form->Text = title;
		}

		void SetProgressMaximum()
		{
			if (form != nullptr && !form->IsDisposed)
				form->progressBar->Maximum = maximum;
		}

		void SetProgressMinimum()
		{
			if (form != nullptr && !form->IsDisposed)
				form->progressBar->Minimum = minimum;
		}

		void buttonCancel_Click(System::Object^ sender, System::EventArgs^ e)
		{
			canceled = true;
		}

		void form_Closing(System::Object^ sender, System::ComponentModel::CancelEventArgs^ e)
		{
			if (!closing)
			{
				canceled = true;
			}
		}

		void form_Activated(System::Object^ sender, System::EventArgs^ e)
		{
			form->Activated -= gcnew System::EventHandler(this, &MorphTest::ProgressDialog::form_Activated);
			startEvent->Set();
		}

		void Run()
		{
			//tH[̐ݒ
			form = gcnew ProgressForm();
			form->Text = title;
			form->buttonCancel->Click += gcnew System::EventHandler(this, &MorphTest::ProgressDialog::buttonCancel_Click);
			form->Closing += gcnew System::ComponentModel::CancelEventHandler(this, &MorphTest::ProgressDialog::form_Closing);
			form->Activated += gcnew System::EventHandler(this, &MorphTest::ProgressDialog::form_Activated);
			form->progressBar->Minimum = minimum;
			form->progressBar->Maximum = maximum;
			form->progressBar->Value = value;
			//tH[̕\ʒuI[i[̒
			if (ownerForm != nullptr)
			{
				form->StartPosition = System::Windows::Forms::FormStartPosition::Manual;
				form->Left =
					ownerForm->Left + (ownerForm->Width - form->Width) / 2;
				form->Top =
					ownerForm->Top + (ownerForm->Height - form->Height) / 2;
			}
			//tH[̕\
			form->ShowDialog();

			delete form;
			form = nullptr;
		}
	public:
		ProgressDialog()
			:canceled(false)
		,showed(false)
		,closing(false)
		,title(L"i")
		,minimum(0)
		,maximum(100)
		,value(0)
		,message(L"")
		{
		}

		property System::String^ Title
		{
			System::String^ get()
			{
				return title;
			}
			void set(System::String^ newvalue)
			{
				title = newvalue;
				if( form != nullptr)
				{
					form->Invoke( gcnew System::Windows::Forms::MethodInvoker(this, &MorphTest::ProgressDialog::SetTitle));
				}
			}
		}

		property System::String^ Message
		{
			System::String^ get()
			{
				return message;
			}
			void set(System::String^ newvalue)
			{
				message = newvalue;
				if( form != nullptr)
				{
					form->Invoke( gcnew System::Windows::Forms::MethodInvoker(this, &MorphTest::ProgressDialog::SetMessage));
				}
			}
		}

		property int Minimum
		{
			int get()
			{
				return minimum;
			}
			void set(int newvalue)
			{
				minimum = newvalue;
				if( form != nullptr)
				{
					form->Invoke( gcnew System::Windows::Forms::MethodInvoker(this, &MorphTest::ProgressDialog::SetProgressMinimum));
				}
			}
		}

		property int Maximum
		{
			int get()
			{
				return maximum;
			}
			void set(int newvalue)
			{
				maximum = newvalue;
				if( form != nullptr)
				{
					form->Invoke( gcnew System::Windows::Forms::MethodInvoker(this, &MorphTest::ProgressDialog::SetProgressMaximum));
				}
			}
		}

		property int Value
		{
			int get()
			{
				return value;
			}
			void set(int newvalue)
			{
				value = newvalue;
				if( form != nullptr)
				{
					form->Invoke( gcnew System::Windows::Forms::MethodInvoker(this, &MorphTest::ProgressDialog::SetProgressValue));
				}
			}
		}

		property bool Canceled
		{
			bool get()
			{
				return canceled;
			}
		}
		
		void Show(System::Windows::Forms::Form^ owner)
		{
			if (showed)
				throw gcnew System::Exception();

			showed = true;

			canceled = false;
			startEvent = gcnew System::Threading::ManualResetEvent(false);
        
			ownerForm = owner;

			//Xbh쐬
			thread = gcnew System::Threading::Thread( gcnew System::Threading::ThreadStart(this, &MorphTest::ProgressDialog::Run));
			thread->IsBackground = true;
			thread->ApartmentState = System::Threading::ApartmentState::STA;
			thread->Start();

			//tH[\܂őҋ@
			startEvent->WaitOne();
		}
    
		void Show()
		{
			Show(nullptr);
		}

		void Close()
		{
			closing = true;
			if( form != nullptr)
			{
				form->Invoke( gcnew System::Windows::Forms::MethodInvoker(form, &System::Windows::Forms::Form::Close));
			}
		}
	};
}
