#pragma once

#include "Morph\Morph.h"

ref class WordCounter
{
private:
	System::Collections::Generic::Dictionary<WordDescription^, int>^ countDictionary;
	Morph^ morph;

public:
	WordCounter(void);
	~WordCounter();

	void Reset();
	void Count(System::IO::StreamReader^ streamReader, long long length);
	void Count(System::String^ line);

	property System::Collections::Generic::List< System::Collections::Generic::KeyValuePair < WordDescription^, int > >^
	Result
	{
		System::Collections::Generic::List< System::Collections::Generic::KeyValuePair < WordDescription^, int > >^ get();
	}

};
